// Editmenu.c
//
//  edit menu functions
//
//  September, 1998
//  jerry@mail.csh.rit.edu

#include "allegro.h"
#include "general.h"
#include "config.h"

BITMAP * clipboard = NULL;


// UNDO / REDO

int edit_undo(void)
{
    return D_O_K;
}

int edit_redo(void)
{
    return D_O_K;
}


// COPY / PASTE (SNARF/BARF)

int edit_copy_sprite(void)
{
    if (current_sprite == NULL)   return D_O_K;

    if (clipboard != NULL) destroy_bitmap(clipboard);

    clipboard = create_bitmap(current_sprite->w, current_sprite->h);

    blit(current_sprite, clipboard, 0, 0, 0, 0, 
         current_sprite->w, current_sprite->h);

    return D_O_K;
}

int edit_paste_sprite(void)
{
    if (current_sprite == NULL)   return D_O_K;

    if (clipboard == NULL)        return D_O_K;

    blit(clipboard, current_sprite, 0, 0, 0, 0, 
         current_sprite->w, current_sprite->h);

    return D_O_K;
}


// RIP FUNCTIONS

int edit_save_pcx(void)
{
    return D_O_K;
}

int edit_load_pcx(void)
{
    return D_O_K;
}


// MISC PREFERENCES 
int do_settings(int msg, DIALOG *d, int c);

// now, because the degui radio button is broken, we gotta use the original
// ALLEGRO 2-D radio button function.  aagh!
#undef d_radio_proc

DIALOG edit_prefs_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  
   		(key) (flags)  (d1)  (d2)  (dp) */

    /// base dialog stuff 
    { d_shadow_box_proc, 0,    0,    320,  240,  0,    0,    
                0,    0,       0,    0,    NULL },
    { d_ctext_proc,      160,  7,    1,    1,    0,    0,    
                0,    0,       0,    0,   "Turaco Preferences"},

#define DE_USE_SUBDIRS (2)
    { d_check_proc,      6, 40, 320, 16, 0, 0, 
                'd', 0, 0, 0, "Use &driver subdirectories" },

#define DE_SINGLE_PLANE (3)
    { d_check_proc,    6, 58, 320, 16, 0, 0, 
                'p', 0, 0, 0, "Single plane fix (Troll Magic)" },

    { d_text_proc,      10,  80,    1,    1,    0,    0,    
                0,    0,       0,    0,   "Rom Paths:"},
    { d_edit_proc,       10, 90, 300, 16, 0, 0, 
                0, 0, ROM_PATH_LEN, 1, ROMPath }, 

    { d_text_proc,      10,  120,    1,    1,    0,    0,    
                0, 0,   0,    0,   "Screen Resolution:"},
#define DE_RESOLUTION (7)
    { d_radio_proc,   20,  130,  140,   10,   0,    0,    
                0, 0,   0,    0,    "320x240", NULL },
    { d_radio_proc,   20,  145,  140,   10,   0,    0,    
                0, 0,   0,    0,    "320x400", NULL },
    { d_radio_proc,   20,  160,  140,   10,   0,    0,    
                0, 0,   0,    0,    "320x480", NULL },
    { d_radio_proc,   150, 130,  140,   10,   0,    0,    
                0, 0,   0,    0,    "640x480", NULL },
    { d_radio_proc,   150, 145,  140,   10,   0,    0,    
                0, 0,   0,    0,    "800x600", NULL },
    { d_radio_proc,   150, 160,  140,   10,   0,    0,    
                0, 0,   0,    0,    "1024x768", NULL },

    { d_button_proc,   230,  210,  80,   16,   0,    0,    
                0,   D_EXIT,  0,    0,    "Close", NULL },

    { do_settings, 0, 0, 320, 0 },
    { NULL, 0, 0, 0, 0, GUI_FORE, GUI_BACK,  0, 0, 0, 0, NULL }
};

void set_button(int which)
{
    edit_prefs_dialog[DE_RESOLUTION].flags &= ~D_SELECTED;
    edit_prefs_dialog[DE_RESOLUTION+1].flags &= ~D_SELECTED;
    edit_prefs_dialog[DE_RESOLUTION+2].flags &= ~D_SELECTED;
    edit_prefs_dialog[DE_RESOLUTION+3].flags &= ~D_SELECTED;
    edit_prefs_dialog[DE_RESOLUTION+4].flags &= ~D_SELECTED;
    edit_prefs_dialog[DE_RESOLUTION+5].flags &= ~D_SELECTED;

    edit_prefs_dialog[DE_RESOLUTION+which].flags |= D_SELECTED;
}

int do_settings(int msg, DIALOG *d, int c)
{
    if (msg == MSG_START)
    {
	if (drv_subdirs)  edit_prefs_dialog[DE_USE_SUBDIRS].flags |= D_SELECTED;
	else              edit_prefs_dialog[DE_USE_SUBDIRS].flags &= ~D_SELECTED;

	if (gfx_hres == 320)
	{
	    if (gfx_vres == 240) set_button(0);
	    else if (gfx_vres == 400) set_button(1);
	    else if (gfx_vres == 480) set_button(2);
	} else if (gfx_hres == 640) set_button(3);
	else if (gfx_hres == 800) set_button(4);
	else if (gfx_hres == 1024) set_button(5);
	else set_button(6);

	d->d1 = gfx_hres;
	d->d2 = gfx_vres;

	if (plane1_hack)  edit_prefs_dialog[DE_SINGLE_PLANE].flags |= D_SELECTED;
	else              edit_prefs_dialog[DE_SINGLE_PLANE].flags &= ~D_SELECTED;

	return D_REDRAW;
    }

    if (msg == MSG_DRAW)
    {
        line(screen, d->x+10, d->y+20, d->x+d->w-10, d->y+20, GUI_FORE);
        line(screen, d->x+10, d->y+21, d->x+d->w-10, d->y+21, GUI_MID);
    }

    if (msg == MSG_END)
    {
        if (edit_prefs_dialog[DE_SINGLE_PLANE].flags & D_SELECTED)
	    plane1_hack = 1;
	else 
	    plane1_hack = 0;

        if (edit_prefs_dialog[DE_USE_SUBDIRS].flags & D_SELECTED)
	    drv_subdirs = 1;
	else 
	    drv_subdirs = 0;

	if(edit_prefs_dialog[DE_RESOLUTION].flags & D_SELECTED)
	    gfx_hres = 320, gfx_vres = 240;
	if(edit_prefs_dialog[DE_RESOLUTION+1].flags & D_SELECTED)
	    gfx_hres = 320, gfx_vres = 400;
	if(edit_prefs_dialog[DE_RESOLUTION+2].flags & D_SELECTED)
	    gfx_hres = 320, gfx_vres = 480;
	if(edit_prefs_dialog[DE_RESOLUTION+3].flags & D_SELECTED)
	    gfx_hres = 640, gfx_vres = 480;
	if(edit_prefs_dialog[DE_RESOLUTION+4].flags & D_SELECTED)
	    gfx_hres = 800, gfx_vres = 600;
	if(edit_prefs_dialog[DE_RESOLUTION+5].flags & D_SELECTED)
	    gfx_hres = 1024, gfx_vres = 768;

	if (gfx_hres != d->d1 || gfx_vres != d->d2)
	    alert("The new screen resolution will", 
	          "be active the next time TURACO",
	          "is restarted", 
	      "Okay", NULL, 0, 0);

    }
    return D_O_K;
}

int edit_preferences(void)
{
    //centre_dialog(edit_prefs_dialog);
    set_dialog_color(edit_prefs_dialog, GUI_FORE, GUI_BACK);
    do_dialog(edit_prefs_dialog, -1);
    return D_REDRAW;
}

